﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfTestingSample.Model;
using Syncfusion.Data;
using Syncfusion.Data.Extensions;

namespace WpfTestingSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }    
    }

    public class DisplayMemberConverter : IValueConverter
    {
        public string DisplayMemberPath { get; set; }
        public string SelectedValuePath { get; set; }
        public object  DataContext { get; set; }

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var selectedValue = value;
            IEnumerable list = null;
            var displayMemberPath = DisplayMemberPath;
            var valueMemberPath = SelectedValuePath;

            list = (DataContext as ViewModel).Companies;
            
            if (selectedValue == null)
                return null;

            PropertyDescriptorCollection pdc = null;

            if (string.IsNullOrEmpty(valueMemberPath))
            {
                if (!string.IsNullOrEmpty(displayMemberPath))
                {
                    var type = selectedValue.GetType();

                    pdc = TypeDescriptor.GetProperties(type);

                    return pdc.GetValue(selectedValue, displayMemberPath);
                }
                return selectedValue;
            }
            else
            {
                if (list == null)
                    return null;

                var enumerator = list.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    var type = enumerator.Current.GetType();
                    pdc = pdc ?? TypeDescriptor.GetProperties(type);

                    if (selectedValue.Equals(pdc.GetValue(enumerator.Current, valueMemberPath)))
                    {
                        if (!string.IsNullOrEmpty(displayMemberPath))
                            return pdc.GetValue(enumerator.Current, displayMemberPath);
                        return enumerator.Current;
                    }
                }
            }
            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }

    }

}
